Subject: Re: [PATCH v2 1/6] mdev: Introduce sha1 based mdev alias

From: Cornelia Huck <[email-masked]>
Date: Fri, 30 Aug 2019 14:39:27 +0200

On Fri, 30 Aug 2019 12:33:22 +0000
Parav Pandit <[email-masked]> wrote:

> > -----Original Message-----
> > From: Cornelia Huck <[email-masked]>
> > Sent: Friday, August 30, 2019 2:47 PM
> > To: Parav Pandit <[email-masked]>
> > Cc: [email-masked]; Jiri Pirko <[email-masked]>;
> > [email-masked]; [email-masked]; [email-masked]; linux-
> > [email-masked]; [email-masked]
> > Subject: Re: [PATCH v2 1/6] mdev: Introduce sha1 based mdev alias
> > 
> > On Thu, 29 Aug 2019 06:18:59 -0500
> > Parav Pandit <[email-masked]> wrote:
> >   
> > > Some vendor drivers want an identifier for an mdev device that is
> > > shorter than the UUID, due to length restrictions in the consumers of
> > > that identifier.
> > >
> > > Add a callback that allows a vendor driver to request an alias of a
> > > specified length to be generated for an mdev device. If generated,
> > > that alias is checked for collisions.
> > >
> > > It is an optional attribute.
> > > mdev alias is generated using sha1 from the mdev name.
> > >
> > > Signed-off-by: Parav Pandit <[email-masked]>
> > >
> > > ---
> > > Changelog:
> > > v1->v2:
> > >  - Kept mdev_device naturally aligned
> > >  - Added error checking for crypt_*() calls
> > >  - Corrected a typo from 'and' to 'an'
> > >  - Changed return type of generate_alias() from int to char*
> > > v0->v1:
> > >  - Moved alias length check outside of the parent lock
> > >  - Moved alias and digest allocation from kvzalloc to kzalloc
> > >  - &alias[0] changed to alias
> > >  - alias_length check is nested under get_alias_length callback check
> > >  - Changed comments to start with an empty line
> > >  - Fixed cleaunup of hash if mdev_bus_register() fails
> > >  - Added comment where alias memory ownership is handed over to mdev
> > > device
> > >  - Updated commit log to indicate motivation for this feature
> > > ---
> > >  drivers/vfio/mdev/mdev_core.c    | 123  
> > ++++++++++++++++++++++++++++++-  
> > >  drivers/vfio/mdev/mdev_private.h |   5 +-
> > >  drivers/vfio/mdev/mdev_sysfs.c   |  13 ++--
> > >  include/linux/mdev.h             |   4 +
> > >  4 files changed, 135 insertions(+), 10 deletions(-)

> > ...and detached from the local variable here. Who is freeing it? The comment
> > states that it is done by the mdev, but I don't see it?
> >   
> mdev_device_free() frees it.

Ah yes, I overlooked the kfree().

> once its assigned to mdev, mdev is the owner of it.
> 
> > This detour via the local variable looks weird to me. Can you either create the
> > alias directly in the mdev (would need to happen later in the function, but I'm
> > not sure why you generate the alias before checking for duplicates anyway), or
> > do an explicit copy?  
> Alias duplicate check is done after generating it, because duplicate alias are not allowed.
> The probability of collision is rare.
> So it is speculatively generated without hold the lock, because there is no need to hold the lock.
> It is compared along with guid while mutex lock is held in single loop.
> And if it is duplicate, there is no need to allocate mdev.
> 
> It will be sub optimal to run through the mdev list 2nd time after mdev creation and after generating alias for duplicate check.

Ok, but what about copying it? I find this "set local variable to NULL
after ownership is transferred" pattern a bit unintuitive. Copying it
to the mdev (and then unconditionally freeing it) looks more obvious to
me.